%define sorev 1

%define _libdir64 %{_prefix}/lib64

Summary:	A modern implementation of a DBM
Name:		tokyocabinet
Version:	1.4.48
Release:	1
License:	LGPLv2+
Group:		Development/Libraries
URL:		http://fallabs.com/tokyocabinet/
Source0:	http://fallabs.com/%{name}/%{name}-%{version}.tar.gz
Patch0:		%{name}-%{version}-aix.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:	AIX-rpm >= 5.2.0.0
BuildRequires:  make
BuildRequires:  bzip2
BuildRequires:	pkg-config
BuildRequires:  zlib-devel >= 1.2.3-3
Requires:	AIX-rpm >= 5.2.0.0
Requires:       bzip2
Requires:       zlib >= 1.2.3-3

%description
Tokyo Cabinet is a library of routines for managing a database. It is the 
successor of QDBM. Tokyo Cabinet runs very fast. For example, the time required
to store 1 million records is 1.5 seconds for a hash database and 2.2 seconds
for a B+ tree database. Moreover, the database size is very small and can be up
to 8EB. Furthermore, the scalability of Tokyo Cabinet is great.

The library is available as 32-bit and 64-bit.


%package devel
Summary:	Headers for developing programs that will use %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	pkg-config

%description devel
This package contains the libraries and header files needed for
developing with %{name}.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with ""xlc_r -q64" or "gcc -maix64".


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="xlc_r"

# shell function to build proper AIX-style shared libraries
build_aix_shared_libs() {
    CreateExportList -X$1 lib%{name}.exp lib%{name}.a
    ${CC} -q$1 -qmkshrobj lib%{name}.a -o lib%{name}.so.%{sorev} -bE:lib%{name}.exp -Wl,-bernotok -lm -lbz2 -lz
    /usr/bin/rm -f lib%{name}.exp lib%{name}.a
    /usr/bin/ar -X$1 -rv lib%{name}.a lib%{name}.so.%{sorev}
}

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --disable-shared --enable-static \
    --enable-off64
gmake %{?_smp_mflags} lib%{name}.a
build_aix_shared_libs 64
gmake %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --disable-shared --enable-static \
    --enable-off64
gmake %{?_smp_mflags} lib%{name}.a
build_aix_shared_libs 32
gmake %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

 "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)

rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/ChangeLog 32bit/COPYING 32bit/README
%{_bindir}/*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_libexecdir}/*
%{_mandir}/man1/*
/usr/bin/*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%doc 32bit/doc/*
%defattr(-,root,system,-)
%{_includedir}/*
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
%{_mandir}/man3/*
/usr/include/*


%changelog
* Tue Jan 08 2013 Michael Perzl <michael@perzl.org> - 1.4.48-1
- updated to version 1.4.48

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 1.4.47-1
- first version for AIX5L v5.1 and higher
